////////////////////////////////////////////////////////////////////////////////
// The HUE Philis driver v 1.1
////////////////////////////////////////////////////////////////////////////////


function GetIDbyIP(HUE) {

    var dev = HUE.hueMainDev;
    dev.SetParameters({
        Host: HUE.Host_IP,
        Port: 80
    });
    if(undefined == HUE.isCanGetId )
        HUE.isCanGetId = true;
    if( !HUE.isCanGetId)
        return;

    dev.Connect();
    IR.Log("~~~~~~~~~~~~~~~~~~~~~~~~~~ GetIDbyIP ");

    if (HUE.settings_data && HUE.settings_data.UserID ) {
        HUE.HueUserID = HUE.settings_data.UserID;
        getTotalConfig(dev);
    } else {
        createUser(dev);
    }

    var timer = IR.SetTimeout(3000, showError);


    var receiveText = '';
    var error = '';
    IR.AddListener(IR.EVENT_OFFLINE, dev, offline_description = function () {

        if (isJson(receiveText)) {
            var jsonObj = JSON.Parse(receiveText);
            receiveText = '';
            if (!(jsonObj instanceof Array))
                jsonObj = [jsonObj];
            var keys = [];
            for (var key in jsonObj[0]) {
                if (jsonObj[0].hasOwnProperty(key))
                    keys.push(key);
            }

            switch (keys[0]) {
                case "error":
                    switch (jsonObj[0].error.type) {
                        case 101:
                            error = jsonObj[0].error.description;
                            HUE.isCanGetId = false;
                            IR.SetTimeout(3000, function () {
                                createUser(dev);
                            });
                            break;
                        case 1:
                            error = jsonObj[0].error.description;
                            break;
                        default:
                            error = jsonObj[0].error.description;
                            break;
                    }
                    break;
                case "success":
                    keys = [];
                    for (var key in jsonObj[0].success)
                        if (jsonObj[0].success.hasOwnProperty(key))
                            keys.push(key);

                    switch (keys[0]) {
                        case "username":
                            error = '';
                            HUE.HueUserID = jsonObj[0].success.username;

                            getTotalConfig(dev);
                            break;
                    }
                    break;
                case "config":
                    error = '';
                    var id = jsonObj[0].config.bridgeid;
                    HUE.settings.setData = {
                        "UserID": HUE.HueUserID,
                        "HueIP": HUE.Host_IP,
                        "BridgeID": HUE.BridgeId
                    };
                    HUE.currentPopup = '';
                    IR.RemoveListener(IR.EVENT_RECEIVE_TEXT, dev, parse_description);
                    dev.Disconnect();
                    HUE.SetupInterface();
                    HUE.isCanGetId = true;
                    IR.HidePopup(HUE.HUE_GUI.EnterIP.Name);
                    HUE.createHub(HUE.Host_IP, id);

                    break;
            }
        }
        if (error != '') {
            showError(error);
        }

    });

    IR.AddListener(IR.EVENT_ERROR, dev, function () {

        showError();
    });
    IR.AddListener(IR.EVENT_RECEIVE_TEXT, dev, parse_description = function (text) {

        IR.ClearInterval(timer);
        receiveText += text;

    });

    function showError(errortext) {
        HUE.HUE_GUI.EnterIP_error.GetState(0).Text = errortext || "HUE hub in this ip not found!";
    }

    function getTotalConfig(dev) {
        dev.Send(['GET,/api/' + HUE.HueUserID]);
    }

    function createUser(dev) {
        dev.Send(['POST,/api,{"devicetype":"my_app#' + IR.HWID.substring(IR.HWID.length - 19, IR.HWID.length) + '"}']);

    }
}


function HUE_local(HUE) {
    IR.Log("Hue con start :        : " + HUE.Hue_connection);

    if (HUE.Hue_connection != 0)
        return;

    IR.SetVariable("Global.HueConnection", 0);


    this.data = undefined;
    
    this.makeFree = function () {
        IR.Log("~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ makeFree: local");
        HUE_destruction();
    }

    this.dev = HUE.hueMainDev;

    var self = this;
    self.dev.SetParameters({
        Host: HUE.Host_IP,
        Port: 80
    });
    self.dev.Connect();
    HUE.settings_data = HUE.settings.getData;
    IR.Log("dddddddddddddddddddddddd " + HUE.settings_data.UserID)
    if (HUE.settings_data && HUE.settings_data.UserID) {
         IR.Log("********************************************************************")
        HUE.HueUserID = HUE.settings_data.UserID;
        self.data = HUE.makeDataArray();
        getall();
    } else
        auth();
        

    function set_switch_sat_bri_hue() { // Setting the propery of the light
        var hsv_color = rgb_to_hsv(red, green, blue);
        setlight(HUE.HUE_GUI.swit.Value ? true : false, hsv_color[1], HUE.HUE_GUI.bri.Value, hsv_color[0]);
    };

    function setSwitch_widget_button() { // Switcher
        setSwitch(HUE.HUE_GUI.Widget_swit.Value ? true : false);
    };

    function setSwitch_button() { // Switcher
        setSwitch(HUE.HUE_GUI.swit.Value ? true : false);
    };

    function setNewColor() { // Set Color via Picker
        color = HUE.HUE_GUI.color.PickColor;
        red = (color >> 24) & 0xFF;
        green = (color >> 16) & 0xFF;
        blue = (color >> 8) & 0xFF;
        set_switch_sat_bri_hue();
    };

    function getall() { // Get all infromation
        IR.Log("getall");
        updatedata(); // Request for update data
    };
    
    function updatedata() { // Request for update data
        IR.Log("update модуль 2  HueUserID  " + HUE.HueUserID);
        /*if (self.data === undefined){
           self.data = [];
           self.data[0] = ",/api";    
           self.data[1] = "";    
        } */
        self.dev.Send(["GET" + self.data[0] + HUE.HueUserID, self.data[1]]); // Send
    };
   

    /*var length = HUE.module.SubDevices.length;
    for (var i = 0; i < length; i++) {
        var name = HUE.module.SubDevices[i].Device;
        if (name.indexOf("Light") >= 0) { // подустройства лампочки
            var lamp = HUE.module.getSubDevice(name);
            var lampData = lamp.getData();
            if (!lampData || !lampData.lightID)
                continue;
            // востановление Actions
            lamp.updateAction("HUE Light " + lampData.lightID + " Off", {
                Method: lightOff,
                Space: {
                    lightID: lampData.lightID
                }
            });
            lamp.updateAction("HUE Light " + lampData.lightID + " On", {
                Method: lightOn,
                Space: {
                    lightID: lampData.lightID
                }
            });

            lamp.updateAction("Set brightness HUE Light " + lampData.lightID, {
                Method: lightBri,
                Space: {
                    lightID: lampData.lightID
                }
            });
            lamp.updateAction("Set color HUE Light " + lampData.lightID, {
                Method: lightSetColor,
                Space: {
                    lightID: lampData.lightID
                }
            });

        }
    }*/

    

    // Parammeters is setted to driver

    light_current = 1; // The current light
    IR.Log(" local start test device : " + self.dev + " , : " + self.dev.Name);
    var color = 0; // The color from Picker in number space
    var red = 0; // The Red color in RGB space
    var green = 0; // The Green color in RGB space
    var blue = 0; // The Blue color in RGB space

    var light_array = []; // Parameters of lights Array
    var state = 0; // A state of connection, 0 - default, 1 - connect

    var id_1 = null;
    var id_timer_end = null;
    this.status = 0;
    var id_timer_repeat = null;
    var listener_test = 0;
    var needFindNewLights = true;
    this.isCanUpdadeInerface = true;
    this.isCanUpdadeBri = true;
    var self = this;
    var briTimer;
    ////////////////////////////////////////////////////////////////////////////////
    //       Parser
    ////////////////////////////////////////////////////////////////////////////////
    var bufferData = "";

    function analize() {
        var t = bufferData;
        bufferData = "";

        if (HUE.Hue_connection != 0 || t == "")
            return;


        IR.ClearInterval(id_timer_repeat);


        if (t.charAt(0) + t.charAt(1) == "<h")
            return;
        if(isJson(t))
           t = JSON.Parse(t); // The JSON is created from received data
        else{
            IR.Log(" analyze cant !! : " + t);
            return;

        }

        var id = []; // Array of indexes is declared
        if (!(t instanceof Array)) // If type of JSON isn't array then it is transformed to array
            t = [t];

        for (var x in t[0]) // Zero item from array of JSON is indexed
            if (t[0].hasOwnProperty(x))
                id.push(x);
        IR.Log(" analyze start keys: " + JSON.Stringify(id)); // looking for coincidence

        switch (id[0]) {

            case "success": // Zero index is message of success
                id = []; // Clear the Array of index
                for (var x in t[0].success) // Success section is indexed
                    if (t[0].success.hasOwnProperty(x))
                        id.push(x);

                switch (id[0]) { // looking for coincidence
                    case "username":
                        HUE.SetupInterface();
                        HUE.HueUserID = t[0].success.username;
                        IR.Log(" ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~username  HueUserID : " + HUE.HueUserID);
                        self.data = HUE.makeDataArray(); // User is authorized | Also, path of read - t.success.username
                        IR.Log("ddddddddddddddddddddddddddddddddddddddddddddddd")
                        getall(); // Send request for get all data of devices on the bridge
                        break;

                    case "/lights": // The search have been started | { "success": { "/lights": "Searching for new devices" } }
                        HUE.HUE_GUI.Connect_status.GetState(0).Text = "Search of lights is continue...";
                        IR.SetTimeout(60000, getall);
                        break;

                    case "1": // requset the count of the lights /api/<username>/lights
                        for (var i = 1; i <= id.length; i++) // fill array lisgts name
                            light_array[i - 1].name = t.success[i.toString()].name;
                        setLightNumber(light_current); // draw list, select current lights
                        IR.Log("setLightNumber : " + light_array[1]);
                        break;

                    default: // ответ на команду мосту
                        self.isCanUpdadeInerface = true;
                        var id_2;

                        for (var i = 0; i < t.length; i++) {

                            for (var x in t[i].success) // Lights section is indexed
                                id_2 = x;
                            IR.Log("id_2 : " + id_2);
                            var nummber = id_2.split("/");
                            //IR.Log(" 4f   : " + id_2.charAt(id_2.length - 2) + id_2.charAt(id_2.length - 1) + "   test : " + light_array); // Inform the user
                            switch (id_2.charAt(id_2.length - 2) + id_2.charAt(id_2.length - 1)) {
                                case "ri":
                                    light_array[nummber[2] - 1].bri = t[i].success[id_2];
                                    break;

                                case "on":
                                    light_array[nummber[2] - 1].swit = t[i].success[id_2];
                                    break;

                                case "ue":
                                    light_array[nummber[2] - 1].hue = t[i].success[id_2];
                                    break;

                                case "at":
                                    light_array[nummber[2] - 1].sat = t[i].success[id_2];
                                    break;
                            }
                        }

                        ColorLoader(); // Draw data
                        break;
                }
                break;

            case "error": // id[0] - error message What to Do!
                switch (t[0].error.type) {
                    case 1: // unauthorized user
                    case 101:

                        HUE.HUE_GUI.Connect_status.GetState(0).Text = "Press the link button on the bridge";
                        //Press the link button on the bridge
                        IR.Log(" ~~~~~~~~~~~~~~~~~~~~~~~~  ERROR 101:");
                        IR.SetTimeout(3000, auth);

                        break;

                    case 2: // syntax error
                        //set_switch_sat_bri_hue();
                        last();
                        break;

                    case 201:

                        break;

                    case 3: // not error happend
                    case 4:
                    case 5:
                    case 6:
                    case 7:
                    case 8:
                    case 301:
                    case 302:
                    case 901:
                        break;
                }
                break;

            case "1": // id[0] - сообщение о состоянии лампы, прочитаем и отобразим
                //IR.Log("  ОБНОВЛЕНИЕ СТАТУСОВ ");
                id = [];
                for (var x in t[0]) // Lights section is indexed
                    if (t[0].hasOwnProperty(x))
                        id.push(x);

                for (var i = 0; i < id.length; i++) {
                    var light_b = t[0][id[i]]; // light in answer from bridge
                    light_array[i].swit = light_b.state.on;
                    light_array[i].sat = light_b.state.sat;
                    light_array[i].bri = light_b.state.bri;
                    light_array[i].hue = light_b.state.hue;
                }
                HUE.DataReflection(light_array);
                if (self.isCanUpdadeInerface)
                    ColorLoader(); // рисуем данные
                break;
            case "config": // id[0] - сообщение о состоянии системы в целом
                HUE.HUE_GUI.Connect_status.GetState(0).Text = "Local connection";

                id = [];
                light_array = [];
                for (var x in t[0].lights) // Lights section is indexed
                    if (t[0].lights.hasOwnProperty(x))
                        id.push(x);
                IR.Log("config : " + id);

                for (var i = 1; i <= id.length; i++) // Filling the array
                {
                    light_array[i - 1] = {
                        name: t[0].lights[id[i - 1]].name,
                        swit: t[0].lights[id[i - 1]].state.on,
                        sat: t[0].lights[id[i - 1]].state.sat,
                        bri: t[0].lights[id[i - 1]].state.bri,
                        hue: t[0].lights[id[i - 1]].state.hue,
                    };

                    /*var lamp = HUE.module.addSubDevice({
                        Device: self.dev, // Передаем устройство, как основной источник информации
                        DeviceName: "Light " + i // Имя устройства, которое видит пользователь
                    });
                    lamp.setData({
                        "lightID": id[i - 1],
                    });*/

                    /*if (undefined == HUE.hueMainDev.GetFeedback("Brightness" + i + HUE.moduleID)) {
                        HUE.hueMainDev.AddTag("Brightness" + i + HUE.moduleID, "01, 00, 00, 00, 00, 00, 00, 00, 00");
                    }
                    if (undefined == HUE.hueMainDev.GetFeedback("Switch" + i + HUE.moduleID)) {
                        HUE.hueMainDev.AddTag("Switch" + i + HUE.moduleID, "01, 00, 00, 00, 00, 00, 00, 00, 00");
                    }*/

                    //   Events
                    /*lamp.addEvent({
                        EventType: "Advanced",
                        ChannelName: "Brightness" + i + HUE.moduleID,
                        Name: "HUE Light " + i + " brightness when less",
                        Field: {
                            ControlType: "Number",
                            Min: 0,
                            Max: 100,
                            Step: 1
                        },
                        Compare: "lt"
                    });

                    lamp.addEvent({
                        EventType: "Advanced",
                        ChannelName: "Brightness" + i + HUE.moduleID,
                        Name: "HUE Light " + i + " brightness when high",
                        Field: {
                            ControlType: "Number",
                            Min: 0,
                            Max: 100,
                            Step: 1
                        },
                        Compare: "gt"
                    });
   
                    lamp.addEvent({
                        Name: "HUE Light " + i + " when off",
                        EventType: "Simple",
                        Param: "0",
                        Compare: "eq",
                        ChannelName: "Switch" + i + HUE.moduleID
                    });

                    lamp.addEvent({
                        Name: "HUE Light " + i + " when on",
                        EventType: "Simple",
                        Param: "1",
                        Compare: "eq",
                        ChannelName: "Switch" + i + HUE.moduleID
                    });
                    //   Conditions
                    lamp.addCondition({
                        EventType: "Advanced",
                        ChannelName: "Brightness" + i + HUE.moduleID,
                        Name: "HUE Light " + i + " brightness is less",
                        Field: {
                            ControlType: "Number",
                            Min: 0,
                            Max: 100,
                            Step: 1
                        },
                        Compare: "lt"
                    });

                    lamp.addCondition({
                        EventType: "Advanced",
                        ChannelName: "Brightness" + i + HUE.moduleID,
                        Name: "HUE Light " + i + " brightness is high",
                        Field: {
                            ControlType: "Number",
                            Min: 0,
                            Max: 100,
                            Step: 1
                        },
                        Compare: "gt"
                    });

                    lamp.addCondition({
                        Name: "HUE Light " + i + " is off",
                        EventType: "Simple",
                        Param: "0",
                        Compare: "eq",
                        ChannelName: "Switch" + i + HUE.moduleID
                    });

                    lamp.addCondition({
                        Name: "HUE Light " + i + " is on",
                        EventType: "Simple",
                        Param: "1",
                        Compare: "eq",
                        ChannelName: "Switch" + i + HUE.moduleID
                    });

                    //   Actions
                    lamp.addAction({
                        ActionType: "Simple",
                        Type: "script_call",
                        Param: 1,
                        Space: {
                            lightID: id[i - 1]
                        },
                        Method: lightOff,
                        Name: "HUE Light " + i + " Off",
                        Smart: "API.Light.Switch.Toggle.Off"
                    });

                    lamp.addAction({
                        ActionType: "Simple",
                        Type: "script_call",
                        Param: 1,
                        Space: {
                            lightID: id[i - 1]
                        },
                        Method: lightOn,
                        Name: "HUE Light " + i + " On",
                        Smart: "API.Light.Switch.Toggle.On"
                    });

                    lamp.addAction({
                        ActionType: "Advanced",
                        Type: "script_call",
                        Space: {
                            lightID: id[i - 1]
                        },
                        Method: lightBri,
                        Name: "Set brightness HUE Light " + i,
                        Smart: "API.Light.Switch.Level.Set",
                        Field: {
                            ControlType: "Number",
                            Min: 0,
                            Max: 100,
                            Step: 1
                        }
                    });

                    lamp.addAction({
                        ActionType: "Advanced",
                        Type: "script_call",
                        Space: {
                            lightID: id[i - 1]
                        },
                        Method: lightSetColor,
                        Name: "Set color HUE Light " + i,
                        Field: {
                            ControlType: "RGB"
                        }
                    }); */

                    //if (IR.GetPopup("Widget" == null)
                        //HUE.makeWidget(i - 1, "HUE Light " + i, lamp); // создание каналов, добавление виджета для каждой лампочки
                    var popup = IR.GetPopup("Widget");


                    if (listener_test == 0) {
                        IR.Log("~~~~~~~~~~~~~~~create HUE.HUE_GUI[Widget]" + i);
                        HUE.HUE_GUI["Widget"] = popup;

                        IR.AddListener(IR.EVENT_ITEM_PRESS, popup.GetItem("buttonFF8000"), function () {
                            light_current = this.light;
                            HUE_PUB_Light_local_FF8000();
                        }, {
                            light: i
                        });
                        IR.AddListener(IR.EVENT_ITEM_PRESS, popup.GetItem("button804000"), function () {
                            light_current = this.light;
                            HUE_PUB_Light_local_804000();
                        }, {
                            light: i
                        });
                        IR.AddListener(IR.EVENT_ITEM_PRESS, popup.GetItem("buttonCCB300"), function () {
                            light_current = this.light;
                            HUE_PUB_Light_local_CCB300();
                        }, {
                            light: i
                        });
                        IR.AddListener(IR.EVENT_ITEM_PRESS, popup.GetItem("buttonFF0080"), function () {
                            light_current = this.light;
                            HUE_PUB_Light_local_FF0080();
                        }, {
                            light: i
                        });
                        IR.AddListener(IR.EVENT_ITEM_PRESS, popup.GetItem("button81FEC2"), function () {
                            light_current = this.light;
                            IR.Log("blue driver local");
                            HUE_PUB_Light_local_81FEC2();
                        }, {
                            light: i
                        });
                        IR.AddListener(IR.EVENT_ITEM_PRESS, popup.GetItem("button00A600"), function () {
                            light_current = this.light;
                            HUE_PUB_Light_local_00A600();
                        }, {
                            light: i
                        });
                        IR.AddListener(IR.EVENT_ITEM_PRESS, popup.GetItem("button8000FF"), function () {
                            light_current = this.light;
                            HUE_PUB_Light_local_8000FF();
                        }, {
                            light: i
                        });
                        IR.AddListener(IR.EVENT_ITEM_PRESS, popup.GetItem("buttonFF80FF"), function () {
                            light_current = this.light;
                            HUE_PUB_Light_local_FF80FF();
                        }, {
                            light: i
                        });
                        IR.AddListener(IR.EVENT_ITEM_PRESS, popup.GetItem("button0080FF"), function () {
                            light_current = this.light;
                            HUE_PUB_Light_local_0080FF();
                        }, {
                            light: i
                        });
                        IR.AddListener(IR.EVENT_ITEM_PRESS, popup.GetItem("button00FFFF"), function () {
                            light_current = this.light;
                            HUE_PUB_Light_local_00FFFF();
                        }, {
                            light: i
                        });
                        IR.AddListener(IR.EVENT_ITEM_PRESS, popup.GetItem("button0000FF"), function () {
                            light_current = this.light;
                            HUE_PUB_Light_local_0000FF();
                        }, {
                            light: i
                        });
                        IR.AddListener(IR.EVENT_ITEM_PRESS, popup.GetItem("button404080"), function () {
                            light_current = this.light;
                            HUE_PUB_Light_local_404080();
                        }, {
                            light: i
                        });


                        IR.AddListener(IR.EVENT_ITEM_PRESS, popup.GetItem("switch"), function () {

                            light_current = this.light;
                            //  setSwitch( Boolean(this.Switch.Value),light_current); //popup.GetItem("switch").Value ? true : false);//
                            PUB_switch(light_current, Boolean(this.Switch.Value)); //popup.GetItem("switch").Value ? true : false);//
                        }, {
                            light: i,
                            Switch: popup.GetItem("switch")
                        });

                        IR.AddListener(IR.EVENT_ITEM_RELEASE, popup.GetItem("Remote"), function () {

                            light_current = this.light;
                            HUE.HUE_GUI.page.GetItem("LightName").GetState(0).Text = light_array[light_current - 1].name;
                            IR.ShowPopup(HUE.HUE_GUI.page.Name);
                        }, {
                            light: i
                        });
                    }

                }
                HUE.DataReflection(light_array);
                HUE.settings.setData = {
                    "UserID": HUE.HueUserID,
                    "HueIP": HUE.Host_IP,
                    "BridgeID": HUE.BridgeId
                };

                if (light_array.length > 0) {
                    HUE.HUE_GUI.Connect_status.GetState(0).Text = "Local connection";
                    listener_test = 1;
                    setLightNumber(light_current); // Draw the light and set current
                    id_1 = IR.SetInterval(3000, getlight);

                } else {
                    HUE.HUE_GUI.Connect_status.GetState(0).Text = "Local connection: No lights";
                    if (needFindNewLights) {
                        searchNewLights();
                        needFindNewLights = false;

                        // удалим старые подустройства
                        /*var length = HUE.module.SubDevices.length;
                        for (var i = 0; i < length; i++) {
                            var name = HUE.module.SubDevices[i].Device;
                            if (name.indexOf("Light") >= 0) {
                                IR.Log("~~~~~~~~~~~~~~~~ module.SubDevices[i].Device ");
                                var subDev = HUE.module.getSubDevice(name);
                                HUE.module.removeSubDevice(subDev);
                            }
                        }*/

                    }
                }
                break;
            // TODO для групп, таймеров и пользователей t[0].schedules[i.toString()]["name"], t[0].groups[i.toString()]["name"], t[0].config.whitelist надо индексировать
        }

    }

    ////////////////////////////////////////////////////////////////////////////////
    //		 Functions
    ////////////////////////////////////////////////////////////////////////////////


    function setLightNumber(n) { // set light and visible current in the list
        light_current = n;
        ColorLoader();
    }

    function ColorLoader() { // измеенние интерфейса
        if (!self.isCanUpdadeInerface) {
            return;
        }
        var color_load;
        for (var i = 0; i < light_array.length; i++) {
            color_load = HSVtoRGB(light_array[i].hue / 65535, light_array[i].sat / 255, 1);
            red = color_load[0];
            green = color_load[1];
            blue = color_load[2];
            var vidget = "Widget";
            //IR.Log("vidget " + vidget + "   is: " + HUE.HUE_GUI[vidget]);
            if (HUE.HUE_GUI[vidget]) {
                color_load_2 = red << 24 | green << 16 | blue << 8 | 0xFF;

                HUE.HUE_GUI[vidget].GetItem("switch").Value = light_array[i].swit;
                HUE.HUE_GUI[vidget].GetItem("switch").GetState(1).FillColor = color_load_2;

            }
        }

        HUE.HUE_GUI.swit.Value = light_array[light_current - 1].swit;

        if (self.isCanUpdadeBri) {
            HUE.HUE_GUI.bri.Value = light_array[light_current - 1].bri;
            HUE.HUE_GUI.page.GetItem("bri_percent").Text = Math.round(light_array[light_current - 1].bri * 100 / 254) + "%";
        }
        color_load = HSVtoRGB(light_array[light_current - 1].hue / 65535, light_array[light_current - 1].sat / 255, 1);
        red = color_load[0];
        green = color_load[1];
        blue = color_load[2];

        HUE.HUE_GUI.red_slider.Value = red;
        HUE.HUE_GUI.green_slider.Value = green;
        HUE.HUE_GUI.blue_slider.Value = blue;

        var color_load_2 = red << 24 | green << 16 | blue << 8 | 0xFF;
        HUE.HUE_GUI.color_detector.GetState(0).FillColor = color_load_2;
        HUE.HUE_GUI.page.GetItem("switch").GetState(1).FillColor = color_load_2;

    }

    function PUB_changeLight(n__, sat__, bri__, hue__) {
        setlight(true, sat__, HUE.HUE_GUI.bri.Value, hue__);

        last = function () {
            setlight(HUE.HUE_GUI.swit.Value ? true : false, sat__, HUE.HUE_GUI.bri.Value, hue__);

        };
    }

    function PUB_switch(n, on) {
        setSwitch(on, n);
    };

    function setSwitch(on, light_n) { // switch the light
        self.isCanUpdadeInerface = false;
        if (!light_n)
            light_n = light_current;
        light_array[light_current - 1].swit = on;
        self.dev.Send(["PUT" + self.data[2] + light_n + "/state," + "{\"on\":" + (on ? true : false) + "}", "\u0000"]);
    };


    function setlight(on, sat, bri, hue, xy, ct, alert, effect, transitiontime) { // change light property
        self.isCanUpdadeInerface = false;

        var color_load = HSVtoRGB(hue / 65535, sat / 255, 1);
        var rgb = color_load[0] << 24 | color_load[1] << 16 | color_load[2] << 8 | 0xFF;
        HUE.HUE_GUI.color_detector.GetState(0).FillColor = rgb;
        HUE.HUE_GUI.swit.GetState(1).FillColor = rgb;
        HUE.HUE_GUI["Widget"].GetItem("switch").GetState(1).FillColor = rgb;

        light_array[light_current - 1].sat = sat;
        light_array[light_current - 1].bri = bri;
        light_array[light_current - 1].hue = hue;
        light_array[light_current - 1].swit = on;

        self.dev.Send(["PUT" + self.data[2] + light_current + "/state," + "{\"on\":" + on + ",\"sat\":" + sat + ",\"bri\":" + bri + ",\"hue\":" + hue + "}", "\u0000"]);
    }

    function setSat(light_n, sat) { // change light property
        self.isCanUpdadeInerface = false;
        if (sat > 255)
            sat = 255;
        if (sat < 0)
            sat = 0;
        if (!light_n)
            light_n = light_current;

        light_array[light_current - 1].sat = sat;
        self.dev.Send(["PUT" + self.data[2] + light_n + "/state," + "{\"sat\":" + sat + "}", "\u0000"]);
    }

    function setBri(light_n, bri) { // change light property
        self.isCanUpdadeInerface = false;
        if (bri > 255)
            bri = 255;
        if (bri < 0)
            bri = 0;
        if (!light_n)
            light_n = light_current;
        light_array[light_current - 1].bri = bri;
        self.dev.Send(["PUT" + self.data[2] + light_n + "/state," + "{\"bri\":" + bri + "}", "\u0000"]);
    }

    function setHUE(light_n, hue_) { // change light property
        self.isCanUpdadeInerface = false;
        if (hue_ > 65535)
            hue_ = 65535;
        if (hue_ < 0)
            hue_ = 0;
        if (!light_n)
            light_n = light_current;
        light_array[light_current - 1].hue = hue_;
        self.dev.Send(["PUT" + self.data[2] + light_n + "/state," + "{\"hue\":" + hue_ + "}", "\u0000"]);
    }

    function setColor(n, color) { // change light property
        self.isCanUpdadeInerface = false;
        red = (color >> 24) & 0xFF;
        green = (color >> 16) & 0xFF;
        blue = (color >> 8) & 0xFF;

        var divider_color = rgb_to_hsv(red, green, blue);
        light_array[light_current - 1].sat = divider_color[2];
        light_array[light_current - 1].bri = divider_color[1];
        light_array[light_current - 1].hue = divider_color[0];

        self.dev.Send(["PUT" + self.data[2] + n + "/state," + "{\"sat\":" + divider_color[2] + ",\"bri\":" + divider_color[1] + ",\"hue\":" + divider_color[0] + "}", "\u0000"]);
    }


    function lightOn() { // action method
        IR.Log("~~~~~~~~~~~~~~~~~~~~~~~~~~~lightOn " + this.lightID);
        self.dev.Send(["PUT" + self.data[2] + this.lightID + "/state," + "{\"on\":" + true + "}", "\u0000"]);
    }

    function lightOff() { //action method
        IR.Log("~~~~~~~~~~~~~~~~~~~~~~~~~~~lightOff " + this.lightID);
        self.dev.Send(["PUT" + self.data[2] + this.lightID + "/state," + "{\"on\":" + false + "}", "\u0000"]);
    }

    function lightBri(bri) { //action method
        IR.Log("~~~~~~~~~~~~~~~~~~~~~~~~~~~lightBri " + this.lightID);
        bri = Math.round(bri * (255 / 100));
        self.dev.Send(["PUT" + self.data[2] + this.lightID + "/state," + "{\"bri\":" + bri + "}", "\u0000"]);
    }

    function lightSetColor(color) { //action method
        IR.Log("~~~~~~~~~~~~~~~~~~~~~~~~~~~lightSetColor " + this.lightID);
        var divider_color = rgb_to_hsv(color.red, color.green, color.blue);
        self.dev.Send(["PUT" + self.data[2] + this.lightID + "/state," + "{\"sat\":" + divider_color[2] + ",\"hue\":" + divider_color[0] + "}", "\u0000"]);
    }

    function auth() { // add user
        var data = {"devicetype":"my_hue_app#" + IR.HWID.substring(IR.HWID.length - 19, IR.HWID.length)}     
        self.dev.SendEx({
            Type: "POST",        															
            Url:  '/api',
            Data: [JSON.Stringify(data)]
        });
    }

    function getlight() { // The inf of the light
        IR.Log("    SEND  getlight " + self.status);
        if (self.status == 1)
            self.dev.Send(["GET" + self.data[2], self.data[1]]);
    }

    function searchNewLights() {
        self.dev.Send(["POST" + self.data[2], self.data[1]]);
    }

    function briDown(delta) {
        self.isCanUpdadeBri = false;
        if (briTimer != undefined || briTimer != null) {
            IR.ClearInterval(briTimer);
        }
        briTimer = IR.SetTimeout(5000, function () {
            self.isCanUpdadeBri = true;
        });
        HUE.HUE_GUI.bri.Value = Math.max(0, HUE.HUE_GUI.bri.Value - delta);
        HUE.HUE_GUI.page.GetItem("bri_percent").Text = Math.round(HUE.HUE_GUI.bri.Value * 100 / 254) + "%";
        set_switch_sat_bri_hue();
    }

    function briUp(delta) {
        self.isCanUpdadeBri = false;
        if (briTimer != undefined || briTimer != null) {
            IR.ClearInterval(briTimer);
        }
        briTimer = IR.SetTimeout(5000, function () {
            self.isCanUpdadeBri = true;
        });
        HUE.HUE_GUI.bri.Value = Math.min(254, HUE.HUE_GUI.bri.Value + delta);
        HUE.HUE_GUI.page.GetItem("bri_percent").Text = Math.round(HUE.HUE_GUI.bri.Value * 100 / 254) + "%";
        set_switch_sat_bri_hue();
    }

    function HUE_destruction() {
        self.dev.Disconnect();
        IR.RemoveListener(IR.EVENT_ITEM_RELEASE, HUE.HUE_GUI.color, setNewColor_local);
        IR.RemoveListener(IR.EVENT_ITEM_RELEASE, HUE.HUE_GUI.bri, set_switch_bri_local);
        IR.RemoveListener(IR.EVENT_ITEM_RELEASE, HUE.HUE_GUI.red_slider, set_switch_redslider_local);
        IR.RemoveListener(IR.EVENT_ITEM_RELEASE, HUE.HUE_GUI.green_slider, set_switch_greenslider_local);
        IR.RemoveListener(IR.EVENT_ITEM_RELEASE, HUE.HUE_GUI.blue_slider, set_switch_blueslider_local);
        IR.RemoveListener(IR.EVENT_ITEM_RELEASE, HUE.HUE_GUI.swit, setSwitch_button_local);
        IR.RemoveListener(IR.EVENT_ITEM_RELEASE, HUE.HUE_GUI.Widget_swit, setSwitch_widget_button_local);

        IR.RemoveListener(IR.EVENT_ITEM_PRESS, HUE.HUE_GUI.page.GetItem("buttonCCB300"), HUE_PUB_Light_buttonCCB300);
        IR.RemoveListener(IR.EVENT_ITEM_PRESS, HUE.HUE_GUI.page.GetItem("buttonFF8000"), HUE_PUB_Light_buttonFF8000);
        IR.RemoveListener(IR.EVENT_ITEM_PRESS, HUE.HUE_GUI.page.GetItem("button804000"), HUE_PUB_Light_button804000);
        IR.RemoveListener(IR.EVENT_ITEM_PRESS, HUE.HUE_GUI.page.GetItem("buttonABC400"), HUE_PUB_Light_buttonABC400);
        IR.RemoveListener(IR.EVENT_ITEM_PRESS, HUE.HUE_GUI.page.GetItem("button808000"), HUE_PUB_Light_button808000);
        IR.RemoveListener(IR.EVENT_ITEM_PRESS, HUE.HUE_GUI.page.GetItem("buttonFF0080"), HUE_PUB_Light_buttonFF0080);
        IR.RemoveListener(IR.EVENT_ITEM_PRESS, HUE.HUE_GUI.page.GetItem("button00A600"), HUE_PUB_Light_button00A600);
        IR.RemoveListener(IR.EVENT_ITEM_PRESS, HUE.HUE_GUI.page.GetItem("button81FEC2"), HUE_PUB_Light_button81FEC2);
        IR.RemoveListener(IR.EVENT_ITEM_PRESS, HUE.HUE_GUI.page.GetItem("button400080"), HUE_PUB_Light_button400080);
        IR.RemoveListener(IR.EVENT_ITEM_PRESS, HUE.HUE_GUI.page.GetItem("button00FFFF"), HUE_PUB_Light_button00FFFF);
        IR.RemoveListener(IR.EVENT_ITEM_PRESS, HUE.HUE_GUI.page.GetItem("button8000FF"), HUE_PUB_Light_button8000FF);
        IR.RemoveListener(IR.EVENT_ITEM_PRESS, HUE.HUE_GUI.page.GetItem("buttonFF80FF"), HUE_PUB_Light_buttonFF80FF);
        IR.RemoveListener(IR.EVENT_ITEM_PRESS, HUE.HUE_GUI.page.GetItem("button0080FF"), HUE_PUB_Light_button0080FF);
        IR.RemoveListener(IR.EVENT_ITEM_PRESS, HUE.HUE_GUI.page.GetItem("button0000FF"), HUE_PUB_Light_button0000FF);
        IR.RemoveListener(IR.EVENT_ITEM_PRESS, HUE.HUE_GUI.page.GetItem("button404080"), HUE_PUB_Light_button404080);

        IR.RemoveListener(IR.EVENT_ITEM_PRESS, HUE.HUE_GUI.page.GetItem("bri_up"), HUE_PUB_Light_bri_up);
        IR.RemoveListener(IR.EVENT_ITEM_PRESS, HUE.HUE_GUI.page.GetItem("bri_down"), HUE_PUB_Light_bri_down);
        IR.RemoveListener(IR.EVENT_ITEM_HOLD, HUE.HUE_GUI.page.GetItem("bri_up"), HUE_PUB_Light_bri_up_hold);
        IR.RemoveListener(IR.EVENT_ITEM_HOLD, HUE.HUE_GUI.page.GetItem("bri_down"), HUE_PUB_Light_bri_down_hold);

        IR.RemoveListener(IR.EVENT_ONLINE, self.dev, online_local);
        IR.RemoveListener(IR.EVENT_ERROR, self.dev, error_local);
        IR.RemoveListener(IR.EVENT_OFFLINE, self.dev, analize_local);
        IR.RemoveListener(IR.EVENT_RECEIVE_TEXT, self.dev, parse_local);
        IR.ClearInterval(id_1);


    };

    ////////////////////////////////////////////////////////////////////////////////
    // Channels Driver
    ////////////////////////////////////////////////////////////////////////////////

    function Requester(name, value) {
        name = name.split(" ");
        switch (name[0]) {
            case "Switch":
                PUB_switch(name[1], Boolean(value));
                break;

            case "Hue":
                setHUE(name[1], value);
                break;

            case "PickColor":
                setColor(name[1], value);
                break;

            case "Brightness":
                setBri(name[1], value);
                break;

            case "Saturation":
                setSat(name[1], value);
                break;

            default:
                IR.Log("The Command not found.");
                break;
        }
    }

    ////////////////////////////////////////////////////////////////////////////////
    // Public functions
    ////////////////////////////////////////////////////////////////////////////////
    function last() {
    };


    ////////////////////////////////////////////////////////////////////////////////
    // Subscribe to events
    ////////////////////////////////////////////////////////////////////////////////
    IR.AddListener(IR.EVENT_ITEM_RELEASE, HUE.HUE_GUI.color, setNewColor_local = function () {
        setNewColor();
    });

    IR.AddListener(IR.EVENT_ITEM_RELEASE, HUE.HUE_GUI.bri, set_switch_bri_local = function () {
        set_switch_sat_bri_hue();
        HUE.HUE_GUI.page.GetItem("bri_percent").Text = Math.round(HUE.HUE_GUI.bri.Value * 100 / 254) + "%";
    });

    IR.AddListener(IR.EVENT_ITEM_PRESS, HUE.HUE_GUI.page.GetItem("bri_down"), HUE_PUB_Light_bri_down = function () {
        briDown(10);
    });

    IR.AddListener(IR.EVENT_ITEM_PRESS, HUE.HUE_GUI.page.GetItem("bri_up"), HUE_PUB_Light_bri_up = function () {
        briUp(10);
    });

    IR.AddListener(IR.EVENT_ITEM_HOLD, HUE.HUE_GUI.page.GetItem("bri_down"), HUE_PUB_Light_bri_down_hold = function () {
        briDown(5);
    });

    IR.AddListener(IR.EVENT_ITEM_HOLD, HUE.HUE_GUI.page.GetItem("bri_up"), HUE_PUB_Light_bri_up_hold = function () {
        briUp(5);
    });

    IR.AddListener(IR.EVENT_ITEM_HOLD, HUE.HUE_GUI.red_slider, set_switch_redslider_local = function () {
        red = HUE.HUE_GUI.red_slider.Value;
        set_switch_sat_bri_hue();
    });
    IR.AddListener(IR.EVENT_ITEM_RELEASE, HUE.HUE_GUI.green_slider, set_switch_greenslider_local = function () {
        green = HUE.HUE_GUI.green_slider.Value;
        set_switch_sat_bri_hue();
    });
    IR.AddListener(IR.EVENT_ITEM_RELEASE, HUE.HUE_GUI.blue_slider, set_switch_blueslider_local = function () {
        blue = HUE.HUE_GUI.blue_slider.Value;
        set_switch_sat_bri_hue();
    });

    IR.AddListener(IR.EVENT_ITEM_RELEASE, HUE.HUE_GUI.swit, setSwitch_button_local = function () {
        setSwitch_button();
    });

    IR.AddListener(IR.EVENT_ITEM_RELEASE, HUE.HUE_GUI.Widget_swit, setSwitch_widget_button_local = function () {
        setSwitch_widget_button();
    });


    function HUE_PUB_All_on() {
        PUB_switch(light_current, true);
    };

    function HUE_PUB_Light_local_FF8000() {
        PUB_changeLight(light_current, 255, 255, 38837);
    }

    function HUE_PUB_Light_local_804000() {

        PUB_changeLight(light_current, 255, 255, 38229);
    }

    function HUE_PUB_Light_local_CCB300() {

        PUB_changeLight(light_current, 255, 255, 34106);
    }

    function HUE_PUB_Light_local_FF0080() {

        PUB_changeLight(light_current, 255, 255, 49173);
    }

    function HUE_PUB_Light_local_81FEC2() {

        PUB_changeLight(light_current, 255, 255, 16165);
    }

    function HUE_PUB_Light_local_00A600() {

        PUB_changeLight(light_current, 255, 255, 21845);
    }

    function HUE_PUB_Light_local_8000FF() {

        PUB_changeLight(light_current, 255, 255, 60052);
    }

    function HUE_PUB_Light_local_FF80FF() {

        PUB_changeLight(light_current, 255, 255, 54613);
    }

    function HUE_PUB_Light_local_0080FF() {
        PUB_changeLight(light_current, 255, 255, 5483);
    }

    function HUE_PUB_Light_local_00FFFF() {

        PUB_changeLight(light_current, 255, 255, 10922);
    }

    function HUE_PUB_Light_local_0000FF() {

        PUB_changeLight(light_current, 255, 255, 0);
    }

    function HUE_PUB_Light_local_404080() {

        PUB_changeLight(light_current, 255, 255, 4529);
    }

    function HUE_PUB_Light_local_ABC400() {

        PUB_changeLight(light_current, 255, 255, 31374);
    }

    function HUE_PUB_Light_local_808000() {

        PUB_changeLight(light_current, 255, 255, 32768);
    }

    function HUE_PUB_Light_local_400080() {

        PUB_changeLight(light_current, 255, 255, 60074);
    }

    IR.AddListener(IR.EVENT_ITEM_PRESS, HUE.HUE_GUI.page.GetItem("buttonCCB300"), HUE_PUB_Light_buttonCCB300 = function () {
        HUE_PUB_Light_local_CCB300();
    });
    IR.AddListener(IR.EVENT_ITEM_PRESS, HUE.HUE_GUI.page.GetItem("buttonFF8000"), HUE_PUB_Light_buttonFF8000 = function () {
        HUE_PUB_Light_local_FF8000();
    });
    IR.AddListener(IR.EVENT_ITEM_PRESS, HUE.HUE_GUI.page.GetItem("button804000"), HUE_PUB_Light_button804000 = function () {
        HUE_PUB_Light_local_804000();
    });
    IR.AddListener(IR.EVENT_ITEM_PRESS, HUE.HUE_GUI.page.GetItem("buttonABC400"), HUE_PUB_Light_buttonABC400 = function () {
        HUE_PUB_Light_local_ABC400();
    });
    IR.AddListener(IR.EVENT_ITEM_PRESS, HUE.HUE_GUI.page.GetItem("button808000"), HUE_PUB_Light_button808000 = function () {
        HUE_PUB_Light_local_808000();
    });
    IR.AddListener(IR.EVENT_ITEM_PRESS, HUE.HUE_GUI.page.GetItem("buttonFF0080"), HUE_PUB_Light_buttonFF0080 = function () {
        HUE_PUB_Light_local_FF0080();
    });
    IR.AddListener(IR.EVENT_ITEM_PRESS, HUE.HUE_GUI.page.GetItem("button00A600"), HUE_PUB_Light_button00A600 = function () {
        HUE_PUB_Light_local_00A600();
    });
    IR.AddListener(IR.EVENT_ITEM_PRESS, HUE.HUE_GUI.page.GetItem("button81FEC2"), HUE_PUB_Light_button81FEC2 = function () {
        HUE_PUB_Light_local_81FEC2();
    });
    IR.AddListener(IR.EVENT_ITEM_PRESS, HUE.HUE_GUI.page.GetItem("button400080"), HUE_PUB_Light_button400080 = function () {
        HUE_PUB_Light_local_400080();
    });
    IR.AddListener(IR.EVENT_ITEM_PRESS, HUE.HUE_GUI.page.GetItem("button00FFFF"), HUE_PUB_Light_button00FFFF = function () {
        HUE_PUB_Light_local_00FFFF();
    });
    IR.AddListener(IR.EVENT_ITEM_PRESS, HUE.HUE_GUI.page.GetItem("button8000FF"), HUE_PUB_Light_button8000FF = function () {
        HUE_PUB_Light_local_8000FF();
    });
    IR.AddListener(IR.EVENT_ITEM_PRESS, HUE.HUE_GUI.page.GetItem("buttonFF80FF"), HUE_PUB_Light_buttonFF80FF = function () {
        HUE_PUB_Light_local_FF80FF();
    });
    IR.AddListener(IR.EVENT_ITEM_PRESS, HUE.HUE_GUI.page.GetItem("button0080FF"), HUE_PUB_Light_button0080FF = function () {
        HUE_PUB_Light_local_0080FF();
    });
    IR.AddListener(IR.EVENT_ITEM_PRESS, HUE.HUE_GUI.page.GetItem("button0000FF"), HUE_PUB_Light_button0000FF = function () {
        HUE_PUB_Light_local_0000FF();
    });
    IR.AddListener(IR.EVENT_ITEM_PRESS, HUE.HUE_GUI.page.GetItem("button404080"), HUE_PUB_Light_button404080 = function () {
        HUE_PUB_Light_local_404080();
    });


    IR.AddListener(IR.EVENT_OFFLINE, self.dev, analize_local = function () {
        analize();
    });
    IR.AddListener(IR.EVENT_ERROR, self.dev, error_local = function () {
        self.status = 0;
    });
    IR.AddListener(IR.EVENT_ONLINE, self.dev, online_local = function () {
        self.status = 1;
    });

    IR.AddListener(IR.EVENT_RECEIVE_TEXT, self.dev, parse_local = function (text) {
        bufferData += text;
    });

}

////////////////////////////////////////////////////////////////////////////////
// End
////////////////////////////////////////////////////////////////////////////////
