////////////////////////////////////////////////////////////////////////////////
// The HUE Philis driver v 1.1
////////////////////////////////////////////////////////////////////////////////

function HUE_cloud(HUE) { // ip arguments is the IP adrees of your bridge

    if (HUE.Hue_connection != 1)
        return;
    IR.SetVariable("Global.HueConnection",1);
    var light_current = 1;

    var Array_for_light = [];
    var light_numb;

    IR.Log("HUE CLOUD is online : " + HUE.Hue_connection);

    receiveText_HueApiId = "";
    receiveText_StatusHueApi = "";
    //     драйвера   StatusHueApi и  HueApiId обращаются на один и тот же сервис
    //     StatusHueApi используется только для запроса состояния (всего хаба)
    //     HueApiId используется для отправки команд

    var HueApiId = IR.CreateDevice(IR.DEVICE_CUSTOM_HTTP_TCP, "HueApi", "www.meethue.com", 443, "", "", true);
    var StatusHueApi = IR.CreateDevice(IR.DEVICE_CUSTOM_HTTP_TCP, "SendHueApi", "client-eastwood-dot-hue-prod-us.appspot.com", 443, "", "", true);
    HueApiId.Connect();
    StatusHueApi.Connect();

    var status_timer = null;

    status_timer = IR.SetInterval(3000, Get_Hue);

    IR.Log("log Token and ID " + HUE.accessToken + "  id : " + HUE.BridgeId);

    this.red = 0; // The Red color in RGB space
    this.green = 0; // The Green color in RGB space
    this.blue = 0; // The Blue color in RGB space

    var self = this;
    var light_array = []; // Parameters of lights Array
    var state = 0; // A state of connection, 0 - default, 1 - connect
    var id_des = null; // The id for link Interval function

    var listener_test = 0;
    var isCanSendNextStatusRqst = true;
    var isCanSendNextCmdRqst = true;

    this.isCanUpadeInerface = true;
    var self = this;

    var lastHueCmd = null;

    /*var length = HUE.module.SubDevices.length;
    for (var i = 0; i < length; i++) {
        var name = HUE.module.SubDevices[i].Device;
        if (name.indexOf("Light") >= 0) { // подустройства лампочки
            var lamp = HUE.module.getSubDevice(name);
            lampData = lamp.getData();
            if (!lampData || !lampData.lightID)
                continue;

            lamp.updateAction("HUE Light " + lampData.lightID + " Off", {
                Method: lightOff,
                Space: {
                    lightID: lampData.lightID
                }
            });
            lamp.updateAction("HUE Light " + lampData.lightID + " On", {
                Method: lightOn,
                Space: {
                    lightID: lampData.lightID
                }
            });

            lamp.updateAction("Set brightness HUE Light " + lampData.lightID, {
                Method: lightBri,
                Space: {
                    lightID: lampData.lightID
                }
            });

            lamp.updateAction("Set color HUE Light " + lampData.lightID, {
                Method: lightSetColor,
                Space: {
                    lightID: lampData.lightID
                }
            });
        }
    }*/

    ////////////////////////////////////////////////////////////////////////////////
    // The Parser
    ////////////////////////////////////////////////////////////////////////////////

    function analize(text, type) {
        if (HUE.Hue_connection != 1) {
            return;
        }
        if (!isJson(text)) {
            return;
        }
        IR.Log("~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ Analize: ");
        HUE.HUE_GUI.Connect_status.GetState(0).Text = "Cloud connection";

        var t = text;
        if (type == 0)
            receiveText_StatusHueApi = "";
        else
            receiveText_HueApiId = "";

        remove_disconect_detector(); // Disconnect detector is removed


        t = JSON.Parse(t); // The JSON is created from received data
        if (t.code) {
            self.isCanUpadeInerface = true;
            if (null != lastHueCmd) {
                Hue_Send(lastHueCmd);
            }
        }
        if (102 == t.code || 109 == t.code) {
            IR.SetVariable("Global.AccessToken", "");
            HUE.accessToken = undefined;
            HUE.HUE_GUI.Connect_status.GetState(0).Text = "Connecting: " + t.message;
            IR.Log("ERROR " + t.message)
            //HueHubs[BridgeId].Start_Hue_connection();
        }

        var id = []; // Array of indexes is declared
        if (!(t instanceof Array)) // If type of JSON isn't array then it is transformed to array
            t = [t];

        for (var x in t[0]) // Zero item from array of JSON is indexed
            if (t[0].hasOwnProperty(x))
                id.push(x);
        IR.Log(" id " + id + " id[0] c " + id[0]); // looking for coincidence


        if (t[0].bridgeIsOnline != true)
            return;

        for (var j = 0; j <= id.length; j++)
            switch (id[j]) {
                case "bridgeIsOnline": // Zero index is message of success
                    IR.Log("bridgeIsOnline : " + t[0].bridgeIsOnline);
                    break;
                case "config":
                    break;
                case "groups":
                    break;
                case "lastHeardFrom":
                    break;
                case "lights":
                    IR.Log("~~lights section");

                    var lightRowArr = [];
                    for (var x in t[0].lights) // Success section is indexed
                        if (t[0].lights.hasOwnProperty(x))
                            lightRowArr.push(x);

                    light_numb = lightRowArr.length;
                    for (var r = 0; r < light_numb; r++) {
                        var popup =  IR.GetPopup("Widget");
                        if (popup == null)
                            break;

                        lightRowArr[r].toString();

                        light_array[r] = {
                            name: t[0].lights[lightRowArr[r]].name,
                            swit: t[0].lights[lightRowArr[r]].state.on,
                            sat: t[0].lights[lightRowArr[r]].state.sat,
                            bri: t[0].lights[lightRowArr[r]].state.bri,
                            hue: t[0].lights[lightRowArr[r]].state.hue,
                        }

                        IR.Log("add in light_array  : " + light_array[r]);
                        if (listener_test == 0) {

                            tr = r + 1;
                            HUE.HUE_GUI["Widget"] = popup;

                            IR.AddListener(IR.EVENT_ITEM_PRESS, popup.GetItem("buttonFF8000"), function () {
                                light_current = this.light;
                                HUE_PUB_Light_cloud_FF8000();
                            }, {
                                light: tr
                            });
                            IR.AddListener(IR.EVENT_ITEM_PRESS, popup.GetItem("button804000"), function () {
                                light_current = this.light;
                                HUE_PUB_Light_cloud_804000();
                            }, {
                                light: tr
                            });
                            IR.AddListener(IR.EVENT_ITEM_PRESS, popup.GetItem("buttonCCB300"), function () {
                                light_current = this.light;
                                HUE_PUB_Light_cloud_CCB300();
                            }, {
                                light: tr
                            });
                            IR.AddListener(IR.EVENT_ITEM_PRESS, popup.GetItem("buttonFF0080"), function () {
                                light_current = this.light;
                                HUE_PUB_Light_cloud_FF0080();
                            }, {
                                light: tr
                            });
                            IR.AddListener(IR.EVENT_ITEM_PRESS, popup.GetItem("button81FEC2"), function () {
                                light_current = this.light;
                                HUE_PUB_Light_cloud_81FEC2();
                            }, {
                                light: tr
                            });
                            IR.AddListener(IR.EVENT_ITEM_PRESS, popup.GetItem("button00A600"), function () {
                                light_current = this.light;
                                HUE_PUB_Light_cloud_00A600();
                            }, {
                                light: tr
                            });
                            IR.AddListener(IR.EVENT_ITEM_PRESS, popup.GetItem("button8000FF"), function () {
                                light_current = this.light;
                                HUE_PUB_Light_cloud_8000FF();
                            }, {
                                light: tr
                            });
                            IR.AddListener(IR.EVENT_ITEM_PRESS, popup.GetItem("buttonFF80FF"), function () {
                                light_current = this.light;
                                HUE_PUB_Light_cloud_FF80FF();
                            }, {
                                light: tr
                            });
                            IR.AddListener(IR.EVENT_ITEM_PRESS, popup.GetItem("button0080FF"), function () {
                                light_current = this.light;
                                HUE_PUB_Light_cloud_0080FF();
                            }, {
                                light: tr
                            });
                            IR.AddListener(IR.EVENT_ITEM_PRESS, popup.GetItem("button00FFFF"), function () {
                                light_current = this.light;
                                HUE_PUB_Light_cloud_00FFFF();
                            }, {
                                light: tr
                            });
                            IR.AddListener(IR.EVENT_ITEM_PRESS, popup.GetItem("button0000FF"), function () {
                                light_current = this.light;
                                HUE_PUB_Light_cloud_0000FF();
                            }, {
                                light: tr
                            });
                            IR.AddListener(IR.EVENT_ITEM_PRESS, popup.GetItem("button404080"), function () {
                                light_current = this.light;
                                HUE_PUB_Light_cloud_404080();
                            }, {
                                light: tr
                            });

                            IR.AddListener(IR.EVENT_ITEM_PRESS, popup.GetItem("switch"), function () {
                                light_current = this.light;
                                setSwitch_widget_button();
                                set_switch_sat_bri_hue();
                            }, {
                                light: lightRowArr[r],
                                Switch: popup.GetItem("switch")
                            });

                            IR.AddListener(IR.EVENT_ITEM_RELEASE, popup.GetItem("Remote"), function () {
                                light_current = this.light;
                                HUE.HUE_GUI.page.GetItem("LightName").GetState(0).Text = light_array[light_current - 1].name;
                                IR.ShowPopup(HUE.HUE_GUI.page.Name);
                            }, {
                                light: tr
                            });
                        }
                    }
                    HUE.DataReflection(light_array);
                    if (0 == listener_test) {
                        setLightNumber(light_current); // Draw the light and set current
                    }
                    if (self.isCanUpadeInerface)
                        ColorLoader();

                    listener_test = 1;

                    break;

                case "scenes":
                    break;
                case "schedules":
                    break;

                case "error": // id[0] - error message What to Do!
                    switch (t[0].error.type) {
                        case 1: // unauthorized user
                        case 101: // link button not pressed
                            break;
                        case 2:
                            last();
                            break;
                        case 201:
                            break;
                        default:
                            HUE.HUE_GUI.Connect_status.GetState(0).Text = t[0].error.description;
                            break;
                    }
                    break;

                case "modelid":
                    IR.Log("modelid"); // id[0] - сообщение о состоянии лампы, прочитаем и отобразим
                    light_array[light_current - 1].swit = t[0].state.on;
                    light_array[light_current - 1].sat = t[0].state.sat;
                    light_array[light_current - 1].bri = t[0].state.bri;
                    light_array[light_current - 1].hue = t[0].state.hue;
                    ColorLoader(); // рисуем данные
                    break;

                case "config": // id[0] - сообщение о состоянии системы в целом
                    IR.Log("~~config section");

                    break;
                // TODO для групп, таймеров и пользователей t[0].schedules[i.toString()]["name"], t[0].groups[i.toString()]["name"], t[0].config.whitelist надо индексировать
            }

    }

    ////////////////////////////////////////////////////////////////////////////////
    // Functions
    ////////////////////////////////////////////////////////////////////////////////


    function Get_Hue() {
        Check();
        if (HUE.Hue_connection == 1 && isCanSendNextStatusRqst) {
            isCanSendNextStatusRqst = false;
            StatusHueApi.SendEx({
                Type: "GET",
                Url: "/api/getbridge?token=" + HUE.accessToken + "&bridgeid=" + HUE.BridgeId,
                Headers: {
                    "Content-Type": "application/x-www-form-urlencoded"
                },
                cbReceiveText: function (text, code, headers) {
                }
            });
        }
    };

    function Hue_message(URLs, Body) {
        clipmessage = {
            bridgeId: HUE.bridgeId,
            clipCommand: {
                url: URLs,
                method: "PUT",
                body: Body
            }
        };
        return clipmessage;
    };

    function Hue_Send(Message) {
        self.isCanUpadeInerface = false;
        IR.Log("~~~~~~~~~~ send cmd from Hue_Send " + isCanSendNextCmdRqst);
        if (!isCanSendNextCmdRqst) {
            lastHueCmd = Message;
            return;
        }
        lastHueCmd = null;
        isCanSendNextCmdRqst = false;

        HueApiId.SendEx({
            Type: "POST",
            Url: "/api/sendmessage?token=" + HUE.accessToken,
            Headers: {
                "Content-Type": "application/x-www-form-urlencoded"
            },
            Data: ['clipmessage=' + JSON.Stringify(Message)],
            cbReceiveText: function (text, code, headers) {
            }
        });

    };

    this.makeFree = function () {
        IR.Log("~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ makeFree: cloud");
        Desctruction_cloud();
    }

    function Desctruction_cloud() {
        HueApiId.Disconnect();
        StatusHueApi.Disconnect();

        IR.RemoveListener(IR.EVENT_ITEM_RELEASE, HUE.HUE_GUI.color, setNewColor_cloud);
        IR.RemoveListener(IR.EVENT_ITEM_RELEASE, HUE.HUE_GUI.bri, set_switch_bri_cloud);
        IR.RemoveListener(IR.EVENT_ITEM_RELEASE, HUE.HUE_GUI.swit, setSwitch_button_cloud);

        IR.RemoveListener(IR.EVENT_ITEM_PRESS, HUE.HUE_GUI.page.GetItem("buttonCCB300"), HUE_PUB_Light_buttonCCB300);
        IR.RemoveListener(IR.EVENT_ITEM_PRESS, HUE.HUE_GUI.page.GetItem("buttonFF8000"), HUE_PUB_Light_buttonFF8000);
        IR.RemoveListener(IR.EVENT_ITEM_PRESS, HUE.HUE_GUI.page.GetItem("button804000"), HUE_PUB_Light_button804000);
        IR.RemoveListener(IR.EVENT_ITEM_PRESS, HUE.HUE_GUI.page.GetItem("buttonABC400"), HUE_PUB_Light_buttonABC400);
        IR.RemoveListener(IR.EVENT_ITEM_PRESS, HUE.HUE_GUI.page.GetItem("button808000"), HUE_PUB_Light_button808000);
        IR.RemoveListener(IR.EVENT_ITEM_PRESS, HUE.HUE_GUI.page.GetItem("buttonFF0080"), HUE_PUB_Light_buttonFF0080);
        IR.RemoveListener(IR.EVENT_ITEM_PRESS, HUE.HUE_GUI.page.GetItem("button00A600"), HUE_PUB_Light_button00A600);
        IR.RemoveListener(IR.EVENT_ITEM_PRESS, HUE.HUE_GUI.page.GetItem("button81FEC2"), HUE_PUB_Light_button81FEC2);
        IR.RemoveListener(IR.EVENT_ITEM_PRESS, HUE.HUE_GUI.page.GetItem("button400080"), HUE_PUB_Light_button400080);
        IR.RemoveListener(IR.EVENT_ITEM_PRESS, HUE.HUE_GUI.page.GetItem("button00FFFF"), HUE_PUB_Light_button00FFFF);
        IR.RemoveListener(IR.EVENT_ITEM_PRESS, HUE.HUE_GUI.page.GetItem("button8000FF"), HUE_PUB_Light_button8000FF);
        IR.RemoveListener(IR.EVENT_ITEM_PRESS, HUE.HUE_GUI.page.GetItem("buttonFF80FF"), HUE_PUB_Light_buttonFF80FF);
        IR.RemoveListener(IR.EVENT_ITEM_PRESS, HUE.HUE_GUI.page.GetItem("button0080FF"), HUE_PUB_Light_button0080FF);
        IR.RemoveListener(IR.EVENT_ITEM_PRESS, HUE.HUE_GUI.page.GetItem("button0000FF"), HUE_PUB_Light_button0000FF);
        IR.RemoveListener(IR.EVENT_ITEM_PRESS, HUE.HUE_GUI.page.GetItem("button404080"), HUE_PUB_Light_button404080);

        IR.RemoveListener(IR.EVENT_ITEM_PRESS, HUE.HUE_GUI.page.GetItem("bri_up"), HUE_PUB_Light_bri_up);
        IR.RemoveListener(IR.EVENT_ITEM_PRESS, HUE.HUE_GUI.page.GetItem("bri_down"), HUE_PUB_Light_bri_down);
        IR.RemoveListener(IR.EVENT_ITEM_RELEASE, HUE.HUE_GUI.red_slider, set_switch_redslider_cloud);
        IR.RemoveListener(IR.EVENT_ITEM_RELEASE, HUE.HUE_GUI.green_slider, set_switch_greenslider_cloud);
        IR.RemoveListener(IR.EVENT_ITEM_RELEASE, HUE.HUE_GUI.blue_slider, set_switch_blueslider_cloud);

        IR.RemoveListener(IR.EVENT_ONLINE, StatusHueApi, StatusHueApi_online);
        IR.RemoveListener(IR.EVENT_OFFLINE, StatusHueApi, Cloud_StatusHueApi_OFFLINE);
        IR.RemoveListener(IR.EVENT_RECEIVE_TEXT, StatusHueApi, Cloud_StatusHueApi_receive_driver);
        IR.RemoveListener(IR.EVENT_OFFLINE, HueApiId, Cloud_HueApiId_OFFLINE);
        IR.RemoveListener(IR.EVENT_RECEIVE_TEXT, HueApiId, Cloud_HueApiId_receive_driver);

        IR.ClearInterval(status_timer);
        IR.ClearInterval(id_des);
    };

    function Check() { // Disconnect Detector is recreate
        remove_disconect_detector(); // Destructed
        id_des = IR.SetTimeout(5000, DisconnectDetector); // recreate
    }

    function remove_disconect_detector() { //  Disconnect Detector is Destructed
        state = 1;
        IR.ClearInterval(id_des);
    }

    function DisconnectDetector() { // disconect manager
        state == 0;
        HUE.HUE_GUI.Connect_status.GetState(0).Text = "Connecting...";
    };

    function setLightNumber(n) { // set light and visible current in the list
        light_current = n;
        ColorLoader();
    }

    function ColorLoader() { // измеенние интерфейса

        IR.Log("Color loader");

        for (var i = 0; i < light_array.length; i++) {
            var color_load = HSVtoRGB(light_array[i].hue / 65535, light_array[i].sat / 255, 1);
            var l_red = color_load[0];
            var l_green = color_load[1];
            var l_blue = color_load[2];

            var vidget = "Widget";
            IR.Log("vidget " + vidget + "   is: " + HUE.HUE_GUI[vidget]);
            if (HUE.HUE_GUI[vidget]) {
                var color_load_2 =  l_red << 24 |  l_green << 16 |  l_blue << 8 | 0xFF;
                HUE.HUE_GUI[vidget].GetItem("switch").Value = light_array[i].swit;
                HUE.HUE_GUI[vidget].GetItem("switch").GetState(1).FillColor = color_load_2;
            }
        }

        HUE.HUE_GUI.swit.Value = light_array[light_current - 1].swit;
        HUE.HUE_GUI.bri.Value = light_array[light_current - 1].bri;
        HUE.HUE_GUI.page.GetItem("bri_percent").Text = Math.round(light_array[light_current - 1].bri * 100 / 254) + "%";

        var color_load = HSVtoRGB(light_array[light_current - 1].hue / 65535, light_array[light_current - 1].sat / 255, 1);
        self.red = color_load[0];
        self.green = color_load[1];
        self.blue = color_load[2];

        HUE.HUE_GUI.red_slider.Value = self. red;
        HUE.HUE_GUI.green_slider.Value =  self.green;
        HUE.HUE_GUI.blue_slider.Value =  self.blue;

        var color_load_2 =  self.red << 24 |  self.green << 16 |  self.blue << 8 | 0xFF;
        HUE.HUE_GUI.color_detector.GetState(0).FillColor = color_load_2;
        HUE.HUE_GUI.page.GetItem("switch").GetState(1).FillColor = color_load_2;

    }

    function set_switch_sat_bri_hue() { // Setting the propery of the light   
        var hsv_color = rgb_to_hsv( self.red,  self.green,  self.blue);    
        IR.Log(self.red +"  "+self.green+"  "+self.blue);
        setlight(HUE.HUE_GUI.swit.Value ? true : false, hsv_color[1], HUE.HUE_GUI.bri.Value, hsv_color[0]);

        last = function () {
            var hsv_color = rgb_to_hsv( self.red,  self.green,  self.blue);
            setlight(HUE.HUE_GUI.swit.Value ? true : false, hsv_color[1], HUE.HUE_GUI.bri.Value, hsv_color[0]);
        }
    }

    function setSwitch_widget_button() { // Switcher
        HUE.HUE_GUI.swit.Value = HUE.HUE_GUI["Widget"].GetItem("switch").Value;
        setSwitch(HUE.HUE_GUI["Widget"].GetItem("switch").Value ? true : false);
    }

    function setSwitch_button() { // Switcher
        HUE.HUE_GUI["Widget"].GetItem("switch").Value = HUE.HUE_GUI.swit.Value;
        setSwitch(HUE.HUE_GUI.swit.Value ? true : false);
    }

    function setNewColor() { // Set Color via Picker
        var color = HUE.HUE_GUI.color.PickColor;
        self.red = (color >> 24) & 0xFF;
        self.green = (color >> 16) & 0xFF;
        self.blue = (color >> 8) & 0xFF;

        set_switch_sat_bri_hue();
    }

    function setlight(on, sat, bri, hue, xy, ct, alert, effect, transitiontime) { // change light property

        IR.Log("===== LOG setlight  light_current: " + light_current + "   	hue: " + hue);

        var color_load = HSVtoRGB(hue / 65535, sat / 255, 1);
        var rgb = color_load[0] << 24 | color_load[1] << 16 | color_load[2] << 8 | 0xFF;


        self.red = color_load[0];
        self.green = color_load[1];
        self.blue = color_load[2];

        HUE.HUE_GUI.swit.GetState(1).FillColor = rgb;
        HUE.HUE_GUI["Widget"].GetItem("switch").GetState(1).FillColor = rgb;
        HUE.HUE_GUI.color_detector.GetState(0).FillColor = rgb;

        light_array[light_current - 1].sat = sat;
        light_array[light_current - 1].bri = bri;
        light_array[light_current - 1].hue = hue;
        light_array[light_current - 1].swit = on;

        Hue_Send(Hue_message("/api/0/lights/" + light_current + "/state", {
            "on": on,
            "sat": sat,
            "bri": bri,
            "hue": hue
        }));

    }

    function setSat(light_n, sat) { // change light property

        if (sat > 255)
            sat = 255;
        if (sat < 0)
            sat = 0;
        if (!light_n)
            light_n = light_current;

        light_array[light_current - 1].sat = sat;
        Hue_Send(Hue_message("/api/0/lights/" + light_n + "/state", {
            "sat": sat
        }));

    }

    function setBri(light_n, bri) { // change light property

        if (bri > 255)
            bri = 255;
        if (bri < 0)
            bri = 0;
        if (!light_n)
            light_n = light_current;

        light_array[light_current - 1].bri = bri;
        Hue_Send(Hue_message("/api/0/lights/" + light_n + "/state", {
            "bri": bri
        }));

    }

    function setHUE(light_n, hue_) { // change light property

        if (hue_ > 65535)
            hue_ = 65535;
        if (hue_ < 0)
            hue_ = 0;
        if (!light_n)
            light_n = light_current;

        light_array[light_current - 1].hue = hue_;
        Hue_Send(Hue_message("/api/0/lights/" + light_n + "/state", {
            "hue": hue_
        }));

    }

    function setColor(n, color) { // change light property

        self.red = (color >> 24) & 0xFF;
        self.green = (color >> 16) & 0xFF;
        self.blue = (color >> 8) & 0xFF;

        var divider_color = rgb_to_hsv(red, green, blue);

        light_array[light_current - 1].sat = divider_color[2];
        light_array[light_current - 1].bri = divider_color[1];
        light_array[light_current - 1].hue = divider_color[0];

        Hue_Send(Hue_message("/api/0/lights/" + light_n + "/state", {
            "sat": divider_color[2],
            "bri": divider_color[1],
            "hue": divider_color[0]
        }));

    }

    function setSwitch(on, light_n) { // switch the light

        if (!light_n)
            light_n = light_current;
        light_array[light_current - 1].swit = on;
        Hue_Send(Hue_message("/api/0/lights/" + light_n + "/state", {
            "on": (on ? true : false)
        }));

    }

    function lightOn() { // action method

        IR.Log("~~~~~~~~~~~~~~~~~~~~~~~~~~~CLOUD lightOn " + this.lightID);
        Hue_Send(Hue_message("/api/0/lights/" + this.lightID + "/state", {
            "on": true
        }));

    }

    function lightOff() { //action method
        //Check();
        IR.Log("~~~~~~~~~~~~~~~~~~~~~~~~~~~ CLOUD lightOff " + this.lightID);
        Hue_Send(Hue_message("/api/0/lights/" + this.lightID + "/state", {
            "on": false
        }));
    }

    function lightBri(bri) { //action method
        //Check();
        IR.Log("~~~~~~~~~~~~~~~~~~~~~~~~~~~CLOUD lightBri " + this.lightID);
        Hue_Send(Hue_message("/api/0/lights/" + this.lightID + "/state", {
            "bri": bri
        }));
    }

    function lightSetColor(color) { //action method

        IR.Log("~~~~~~~~~~~~~~~~~~~~~~~~~~~CLOUD lightSetColor " + this.lightID);
        var divider_color = rgb_to_hsv(color.red, color.green, color.blue);
        Hue_Send(Hue_message("/api/0/lights/" + this.lightID + "/state", {
            "sat": divider_color[2],
            "hue": divider_color[0]
        }));
    }

    function HUE_PUB_Light_cloud_FF8000() {

        PUB_changeLight(light_current, 255, 255, 38837);
    }

    function HUE_PUB_Light_cloud_804000() {

        PUB_changeLight(light_current, 255, 255, 38229);
    }

    function HUE_PUB_Light_cloud_CCB300() {

        PUB_changeLight(light_current, 255, 255, 34106);
    }

    function HUE_PUB_Light_cloud_FF0080() {

        PUB_changeLight(light_current, 255, 255, 49173);
    }

    function HUE_PUB_Light_cloud_81FEC2() {

        PUB_changeLight(light_current, 255, 255, 16165);
    }

    function HUE_PUB_Light_cloud_00A600() {

        PUB_changeLight(light_current, 255, 255, 21845);
    }

    function HUE_PUB_Light_cloud_8000FF() {

        PUB_changeLight(light_current, 255, 255, 60052);
    }

    function HUE_PUB_Light_cloud_FF80FF() {

        PUB_changeLight(light_current, 255, 255, 54613);
    }

    function HUE_PUB_Light_cloud_0080FF() {
        PUB_changeLight(light_current, 255, 255, 5483);
    }

    function HUE_PUB_Light_cloud_00FFFF() {

        PUB_changeLight(light_current, 255, 255, 10922);
    }

    function HUE_PUB_Light_cloud_0000FF() {

        PUB_changeLight(light_current, 255, 255, 0);
    }

    function HUE_PUB_Light_cloud_404080() {

        PUB_changeLight(light_current, 255, 255, 4529);
    }

    function HUE_PUB_Light_cloud_ABC400() {

        PUB_changeLight(light_current, 255, 255, 31374);
    }

    function HUE_PUB_Light_cloud_808000() {

        PUB_changeLight(light_current, 255, 255, 32768);
    }

    function HUE_PUB_Light_cloud_400080() {

        PUB_changeLight(light_current, 255, 255, 60074);
    }

    ////////////////////////////////////////////////////////////////////////////////
    // Public functions
    ////////////////////////////////////////////////////////////////////////////////
    function last() {
    };

    function PUB_changeLight(n__, sat__, bri__, hue__) {

        setlight(HUE.HUE_GUI.swit.Value ? true : false, sat__, HUE.HUE_GUI.bri.Value, hue__);
        last = function () {
            setlight(HUE.HUE_GUI.swit.Value ? true : false, sat__, HUE.HUE_GUI.bri.Value, hue__);

        };
    }

     function PUB_switch (n, on) {
        IR.Log("Pub Switch");
        setSwitch(on, n);
    }

    ////////////////////////////////////////////////////////////////////////////////
    // Subscribe to events       ....
    ////////////////////////////////////////////////////////////////////////////////
    IR.AddListener(IR.EVENT_ITEM_RELEASE, HUE.HUE_GUI.color, setNewColor_cloud = function () {
        setNewColor();
    });

    IR.AddListener(IR.EVENT_ITEM_RELEASE, HUE.HUE_GUI.bri, set_switch_bri_cloud = function () {
        set_switch_sat_bri_hue();
        HUE.HUE_GUI.page.GetItem("bri_percent").Text = Math.round(HUE.HUE_GUI.bri.Value * 100 / 254) + "%";
    });
    IR.AddListener(IR.EVENT_ITEM_PRESS, HUE.HUE_GUI.page.GetItem("bri_down"), HUE_PUB_Light_bri_down = function () {
        if (!self.isCanUpadeInerface) {
            return;
        }
        HUE.HUE_GUI.bri.Value -= 10;
        HUE.HUE_GUI.page.GetItem("bri_percent").Text = Math.round(HUE.HUE_GUI.bri.Value * 100 / 254) + "%";
        set_switch_sat_bri_hue();
    });
    IR.AddListener(IR.EVENT_ITEM_PRESS, HUE.HUE_GUI.page.GetItem("bri_up"), HUE_PUB_Light_bri_up = function () {
        if (!self.isCanUpadeInerface) {
            return;
        }
        HUE.HUE_GUI.bri.Value += 10;
        HUE.HUE_GUI.page.GetItem("bri_percent").Text = Math.round(HUE.HUE_GUI.bri.Value * 100 / 254) + "%";
        set_switch_sat_bri_hue();
    });

    IR.AddListener(IR.EVENT_ITEM_RELEASE, HUE.HUE_GUI.red_slider, set_switch_redslider_cloud = function () {
        self.red = HUE.HUE_GUI.red_slider.Value;
        set_switch_sat_bri_hue();
    });
    IR.AddListener(IR.EVENT_ITEM_RELEASE, HUE.HUE_GUI.green_slider, set_switch_greenslider_cloud = function () {
        self.green = HUE.HUE_GUI.green_slider.Value;
        set_switch_sat_bri_hue();
    });
    IR.AddListener(IR.EVENT_ITEM_RELEASE, HUE.HUE_GUI.blue_slider, set_switch_blueslider_cloud = function () {
        self.blue = HUE.HUE_GUI.blue_slider.Value;
        set_switch_sat_bri_hue();
    });

    IR.AddListener(IR.EVENT_ITEM_RELEASE, HUE.HUE_GUI.swit, setSwitch_button_cloud = function () {
        setSwitch_button(); // switch
        set_switch_sat_bri_hue();
    });


    IR.AddListener(IR.EVENT_ITEM_PRESS, HUE.HUE_GUI.page.GetItem("buttonCCB300"), HUE_PUB_Light_buttonCCB300 = function () {
        HUE_PUB_Light_cloud_CCB300();
    });
    IR.AddListener(IR.EVENT_ITEM_PRESS, HUE.HUE_GUI.page.GetItem("buttonFF8000"), HUE_PUB_Light_buttonFF8000 = function () {
        HUE_PUB_Light_cloud_FF8000();
    });
    IR.AddListener(IR.EVENT_ITEM_PRESS, HUE.HUE_GUI.page.GetItem("button804000"), HUE_PUB_Light_button804000 = function () {
        HUE_PUB_Light_cloud_804000();
    });
    IR.AddListener(IR.EVENT_ITEM_PRESS, HUE.HUE_GUI.page.GetItem("buttonABC400"), HUE_PUB_Light_buttonABC400 = function () {
        HUE_PUB_Light_cloud_ABC400();
    });
    IR.AddListener(IR.EVENT_ITEM_PRESS, HUE.HUE_GUI.page.GetItem("button808000"), HUE_PUB_Light_button808000 = function () {
        HUE_PUB_Light_cloud_808000();
    });
    IR.AddListener(IR.EVENT_ITEM_PRESS, HUE.HUE_GUI.page.GetItem("buttonFF0080"), HUE_PUB_Light_buttonFF0080 = function () {
        HUE_PUB_Light_cloud_FF0080();
    });
    IR.AddListener(IR.EVENT_ITEM_PRESS, HUE.HUE_GUI.page.GetItem("button00A600"), HUE_PUB_Light_button00A600 = function () {
        HUE_PUB_Light_cloud_00A600();
    });
    IR.AddListener(IR.EVENT_ITEM_PRESS, HUE.HUE_GUI.page.GetItem("button81FEC2"), HUE_PUB_Light_button81FEC2 = function () {
        HUE_PUB_Light_cloud_81FEC2();
    });
    IR.AddListener(IR.EVENT_ITEM_PRESS, HUE.HUE_GUI.page.GetItem("button400080"), HUE_PUB_Light_button400080 = function () {
        HUE_PUB_Light_cloud_400080();
    });
    IR.AddListener(IR.EVENT_ITEM_PRESS, HUE.HUE_GUI.page.GetItem("button00FFFF"), HUE_PUB_Light_button00FFFF = function () {
        HUE_PUB_Light_cloud_00FFFF();
    });
    IR.AddListener(IR.EVENT_ITEM_PRESS, HUE.HUE_GUI.page.GetItem("button8000FF"), HUE_PUB_Light_button8000FF = function () {
        HUE_PUB_Light_cloud_8000FF();
    });
    IR.AddListener(IR.EVENT_ITEM_PRESS, HUE.HUE_GUI.page.GetItem("buttonFF80FF"), HUE_PUB_Light_buttonFF80FF = function () {
        HUE_PUB_Light_cloud_FF80FF();
    });
    IR.AddListener(IR.EVENT_ITEM_PRESS, HUE.HUE_GUI.page.GetItem("button0080FF"), HUE_PUB_Light_button0080FF = function () {
        HUE_PUB_Light_cloud_0080FF();
    });
    IR.AddListener(IR.EVENT_ITEM_PRESS, HUE.HUE_GUI.page.GetItem("button0000FF"), HUE_PUB_Light_button0000FF = function () {
        HUE_PUB_Light_cloud_0000FF();
    });
    IR.AddListener(IR.EVENT_ITEM_PRESS, HUE.HUE_GUI.page.GetItem("button404080"), HUE_PUB_Light_button404080 = function () {
        HUE_PUB_Light_cloud_404080();
    });

    // события Http драйверов

    IR.AddListener(IR.EVENT_ONLINE, StatusHueApi, StatusHueApi_online = function () {
        remove_disconect_detector();
    });

    IR.AddListener(IR.EVENT_RECEIVE_TEXT, StatusHueApi, Cloud_StatusHueApi_receive_driver = function (text) {
        IR.Log("EVENT_RECEIVE_TEXT  StatusHueApi ");
        remove_disconect_detector();
        receiveText_StatusHueApi += text;

    });

    IR.AddListener(IR.EVENT_RECEIVE_TEXT, HueApiId, Cloud_HueApiId_receive_driver = function (text) {
        IR.Log("EVENT_RECEIVE_TEXT  HueApiId ");
        receiveText_HueApiId += text;

    });

    IR.AddListener(IR.EVENT_OFFLINE, StatusHueApi, Cloud_StatusHueApi_OFFLINE = function () {
        IR.Log("EVENT_OFFLINE  StatusHueApi\r\n ");
        isCanSendNextStatusRqst = true;

        analize(receiveText_StatusHueApi, 0);
        receiveText_StatusHueApi = '';

    });

    IR.AddListener(IR.EVENT_OFFLINE, HueApiId, Cloud_HueApiId_OFFLINE = function () {
        IR.Log("EVENT_OFFLINE  HueApiId\r\n ");
        isCanSendNextCmdRqst = true;
        analize(receiveText_HueApiId, 1);
        receiveText_HueApiId = '';

    });

}
////////////////////////////////////////////////////////////////////////////////
// End
////////////////////////////////////////////////////////////////////////////////
